app/Http/routes.php
<?php

Route::get('/', [
    'as' => 'home',
    'uses' => 'PagesController@index'
]);

Route::get('/dashboard', [
    'as' => 'dashboard',
    'middleware' => 'auth',
    'uses' => 'DashboardController@index'
]);



Route::group(['prefix' => 'api'], function() {

    /*
     * JWT-protected Routes
    */
    Route::group(['middleware' => 'api'], function() {

        Route::get('/rate', [
            'as' => 'api.rates',
            'uses' => 'RatesController@calculate'
        ]);
        
    });

    Route::post('auth/token', 'JWTController@postToken');
    Route::get('auth/token', 'JWTController@token');

    //individual api endpoints
    Route::get('remove-country-group', [
        'as' => 'api.remove-country-group',
        'uses' => 'AdminController@removeCountryGroup'
    ]);

});

Route::group(['prefix' => 'admin', 'middleware' => 'auth'], function() {

    Route::resource('tokens', 'TokensController', ['except' => 'show']);
    Route::resource('countries', 'CountriesController', ['except' => 'show']);
    Route::resource('groups', 'GroupsController', ['except' => 'show']);
    Route::resource('rates', 'RatesController', ['only' => ['edit', 'update']]);

    //Single Routes
    Route::get('/', [
        'as' => 'admin.index',
        'uses' => 'AdminController@index'
    ]);
    Route::post('add-country-group', [
        'as' => 'admin.add-country-group',
        'uses' => 'CountryGroupController@postAdd'
    ]);

});

Route::auth();

app/Group.php
<?php

namespace App;

use App\BaseModel;

class Group extends BaseModel
{
    protected $fillable = ['label_en', 'label_ja', 'zone'];
    protected $rules = [
        'label_en' => 'required|max:50'
    ];

    public function countries() {
        return $this->belongsToMany('App\Country')->orderBy('name_en');
    }

    public function rates() {
        return $this->hasMany('App\Rate')->orderBy('weight');
    }

    public function getLabel() {
        return sprintf('%s Zone %d', $this->label_en, $this->zone);
    }
}

app/Http/Controllers/GroupsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests;
use App\Group;

class GroupsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $groups = Group::paginate(25);

        return view('admin.groups.index', [
            'groups' => $groups
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.groups.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $group = new Group();
        $validated = $group->validate($request->all());

        if ($validated->fails()) {
            return redirect()
                ->route('admin.countries.create')
                ->withInput()
                ->with('flash', [
                    'type' => 'error',
                    'message' => $validated->errors()
                ]);
        }

        $group->fill($request->all())->save();

        return redirect()
            ->route('admin.groups.index')
            ->with('flash', [
                'type' => 'success',
                'message' => trans('site.forms.messages.success')
            ]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $group = Group::find($id);
        return view('admin.groups.edit', [
            'group' => $group
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $group = Group::find($id);
        $validated = $group->validate($request->all());

        if ($validated->fails()) {
            return redirect()
                ->route('admin.groups.edit', ['id' => $group->id])
                ->withInput()
                ->with('flash', [
                    'type' => 'error',
                    'message' => $validated->errors()
                ]);
        }

        $group->fill($request->all())->save();

        return redirect()
            ->route('admin.groups.index')
            ->with('flash', [
                'type' => 'success',
                'message' => trans('site.forms.messages.success')
            ]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Group::destroy($id);
        return response()->json(1);
    }
}

resources/views/admin/groups/create.blade.php
@extends('layouts.master')

@section('title', trans('site.page_titles.admin.groups'))

@section('content')
<div class="row">
    <div class="col s6 offset-s3">
        <form method="post" action="{{ route('admin.groups.store') }}">
            <div class="row">
                <div class="col s12">
                    <h2>{{ trans('site.headers.admin.add', ['type' => 'Group']) }}</h2>
                </div>
            </div>
            <div class="row">
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="label_en" id="labelEn" />
                        <label for="labelEn" maxlength="50" value="{{ old('label_en') }}" required="required">{{ trans('site.forms.labels.label_en') }}</label>
                    </div>
                </div>
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="label_ja" maxlength="50" id="labelJa" value="{{ old('label_ja') }}" />
                        <label for="labelJa">{{ trans('site.forms.labels.label_ja') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="inline-radio">
                        <input name="zone" type="radio" value="1" id="zone1" checked="checked" /><label for="zone1">Zone 1</label>
                        <input name="zone" type="radio" value="2" id="zone2" /><label for="zone2">Zone 2</label>
                        <input name="zone" type="radio" value="3" id="zone3" /><label for="zone3">Zone 3</label>
                        <input name="zone" type="radio" value="4" id="zone4" /><label for="zone4">Zone 4</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        {!! csrf_field() !!}
                        <button type="submit" class="waves-effect waves-light black btn">{{ trans('site.forms.actions.create_type', ['type' => 'Group']) }}</button>
                        <a href="{{ route('admin.groups.index') }}" class="waves-effect waves-teal btn-flat">{{ trans('site.actions.cancel') }}</a>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>

@endsection

resources/views/admin/groups/edit.blade.php
@extends('layouts.master')

@section('title', trans('site.page_titles.admin.groups'))

@section('content')
<div class="row">
    <div class="col s6 offset-s3">
        <form method="post" action="{{ route('admin.groups.update', ['id' => $group->id]) }}">
            <div class="row">
                <div class="col s12">
                    <h2>{{ trans('site.headers.admin.edit', ['type' => 'Group', 'id' => $group->id]) }}</h2>
                </div>
            </div>
            <div class="row">
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="label_en" value="{{ $group->label_en }}" id="labelEn" />
                        <label for="labelEn" @if(!empty($group->label_en))class="active" @endif>{{ trans('site.forms.labels.label_en') }}</label>
                    </div>
                </div>
                <div class="col s6">
                    <div class="input-field">
                        <input type="text" name="label_ja" value="{{ $group->label_ja }}" id="labelJa" />
                        <label for="labelJa" @if(!empty($group->label_ja))class="active" @endif>{{ trans('site.forms.labels.label_ja') }}</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="inline-radio">
                        <input name="zone" type="radio" value="1" id="zone1" @if($group->zone == 1) checked="checked"@endif/><label for="zone1">Zone 1</label>
                        <input name="zone" type="radio" value="2" id="zone2" @if($group->zone == 2) checked="checked"@endif/><label for="zone2">Zone 2</label>
                        <input name="zone" type="radio" value="3" id="zone3" @if($group->zone == 3) checked="checked"@endif/><label for="zone3">Zone 3</label>
                        <input name="zone" type="radio" value="4" id="zone4"@if($group->zone == 4) checked="checked"@endif /><label for="zone4">Zone 4</label>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        {!! csrf_field() !!}
                        <input name="_method" type="hidden" value="PUT">
                        <button type="submit" class="waves-effect waves-light black btn">{{ trans('site.forms.actions.edit') }}</button>
                        <a href="{{ route('admin.groups.index') }}" class="waves-effect waves-teal btn-flat">{{ trans('site.actions.cancel') }}</a>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>

@endsection

resources/views/admin/groups/index.blade.php
@extends('layouts.master')

@section('title', trans('site.page_titles.admin.groups'))

@section('content')
<div class="container">
    @include('elements.flash')
    <h1>{{ trans('site.headers.admin.groups') }}</h1>
    <table class="striped bordered">
        <thead>
            <tr>
                <th class="id">{{ trans('site.tables.headers.id') }}</th>
                <th>{{ trans('site.tables.headers.label') }}</th>
                <th class="text-center">{{ trans('site.tables.headers.zone') }}</th>
                <th class="action">
                    <a href="{{ route('admin.groups.create') }}" class="btn-floating btn-small waves-effect waves-light green"><i class="material-icons">add</i>
                    </a>
                </th>
            </tr>
        </thead>
        <tbody>
            @foreach($groups as $group)
                <tr>
                    <td class="id">{{ $group->id }}</td>
                    <td>{{ $group->getField('label') }}</td>
                    <td class="text-center">{{ $group->zone }}</td>
                    <td class="action">
                        <a href="{{ route('admin.groups.destroy', ['id' => $group->id]) }}" onClick="javascript: return window.confirm('Are you sure?');" class="btn-flat waves-effect waves-light remove-resource"><i class="material-icons">delete</i></a>  
                        <a href="{{ route('admin.groups.edit', ['id' => $group->id]) }}" class="btn-floating btn-small waves-effect waves-light orange"><i class="material-icons">mode_edit</i></a>
                    </td>            
                </tr>
            @endforeach
        </tbody>
    </table>
</div>
@endsection